## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005

from CvPythonExtensions import *
import CvUtil
import CvEventManager
import sys
import AbandonRazeDemolish
	
gc = CyGlobalContext()

ard = AbandonRazeDemolish.AbandonRazeDemolish()

# globals
###################################################
class CvCustomEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)
		self.Events[7500] = ('DestroyBuildingPopup', self.__eventDestroyBuildingApply , self.__eventDestroyBuildingBegin)

	def __eventDestroyBuildingApply(self, playerID, userData, popupReturn):
		ard.eventDestroyBuildingApply(playerID, userData, popupReturn)
		
	def __eventDestroyBuildingBegin(self, argsList):
		ard.eventDestroyBuildingBegin(argsList)
		
	def onKbdEvent(self, argsList):
		if (ard.onKbdEvent(argsList, self.bCtrl) == 1):
			self.beginEvent(7500)
			return 1
		CvEventManager.CvEventManager().onKbdEvent(argsList)

	def onCityRazed(self, argsList):
		self.parent.onCityRazed(self, argsList)
		ard.onCityRazed(argsList)